﻿601,100
562,"NULL"
586,
585,
564,
565,"tcTfUeL0<f2[meUZ:iSba0VOg\p3s3p_bY^hrJgmfYEsh]MLTwXYbFSsvZ;J2gSj9=rKv;ax_btRxZyr5LgTQo6PdM\9Txc7aowDbT@c?2y0O5fY<[Z@3eDyaRteR\_ungzv`1eMjzJNPX`9Qy74Q3zP_w<hJ:DFubw:=t>wC1@GMIqLT3l:;wjxD=lDq1@X4`Dksyp7"
559,1
928,0
593,
594,
595,
597,
598,
596,
800,
801,
566,0
567,","
588,"."
589,
568,""""
570,
571,
569,0
592,0
599,1000
560,2
pExecutionId
pControl
561,2
2
2
590,2
pExecutionId,"None"
pControl,"N"
637,2
pExecutionId,
pControl,
577,0
578,0
579,0
580,0
581,0
582,0
572,278


#################################################################
## IBM Confidential
##
## OCO Source Materials
##
## BI and PM: pmpsvc
##
## (C) Copyright IBM Corp. 2008, 2009
##
## The source code for this program is not published or otherwise
## divested of its trade secrets, irrespective of what has been
## deposited with the U.S. Copyright Office.
#################################################################



cControlPrefix = '';
If (pControl @= 'Y');
cControlPrefix = '}';
EndIf;

#*** Create tp_lock

cLockDim = cControlPrefix | 'tp_lock';
cLock = 'Lock';
If (DimensionExists(cLockDim) = 0);
DimensionCreate(cLockDim);
DimensionElementInsert(cLockDim, '', cLock, 'S');
EndIf;

cTiExecutionDim = cControlPrefix | 'tp_ti_execution';
cId = 'Id';
If (DimensionExists(cTiExecutionDim) = 0);
DimensionCreate(cTiExecutionDim);
DimensionElementInsert(cTiExecutionDim, '', cId, 'S');
EndIf;

cSemaphoreCube = cControlPrefix | 'tp_semaphore';
If (CubeExists(cSemaphoreCube) = 0);
CubeCreate(cSemaphoreCube, cLockDim, cTiExecutionDim);
CubeSetLogChanges(cSemaphoreCube, 1);
EndIf;

#*** Create "everyone" group

cSystemConfigDim = cControlPrefix | 'tp_system_config';
If (DimensionExists(cSystemConfigDim) = 0);
ProcessError;
EndIf;

cSecurityModeNode = 'IntegratedSecurityMode';
cConfigValueAttr = 'ConfigValue';
vSecurityMode = ATTRS(cSystemConfigDim, cSecurityModeNode, cConfigValueAttr);

cCognosEveryoneGroup = 'CAMID("::Everyone")';
cTpEveryoneGroup = cControlPrefix | 'tp_Everyone';
If (vSecurityMode @= '5');

If (DIMIX('}Groups', cCognosEveryoneGroup) = 0);
ProcessError;
EndIf;

If (DIMIX('}Groups', cTpEveryoneGroup) <> 0);
DeleteGroup(cTpEveryoneGroup);
EndIf;

cEveryoneGroup = cCognosEveryoneGroup;

Else;

cEveryoneGroup = cTpEveryoneGroup;

If (DIMIX('}Groups', cEveryoneGroup) = 0);
AddGroup(cEveryoneGroup);
EndIf;

EndIf;


#***create error log objects
cErrorCube = cControlPrefix | 'tp_process_errors';
If (CubeExists(cErrorCube) = 0);
vReturnValue = ExecuteProcess(cControlPrefix | 'tp_error_setup', 'pControl', pControl);
If (vReturnValue <> ProcessExitNormal());
ProcessError;
EndIf;
EndIf;

#*** Log File Name
cTM1Process = cControlPrefix | 'tp_create_planning_artifacts';
StringGlobalVariable('gPrologLog');
StringGlobalVariable('gEpilogLog');
vReturnValue = ExecuteProcess(cControlPrefix | 'tp_get_log_file_names', 
'pExecutionId', pExecutionId, 'pProcess', cTM1Process, 'pControl', pControl);
If (vReturnValue <> ProcessExitNormal());
ProcessError;
EndIf;
cPrologLog = gPrologLog;
cEpilogLog = gEpilogLog;
cTM1Log = cPrologLog;

cConfigDim = cControlPrefix | 'tp_config';
If (DimensionExists(cConfigDim) = 1);
cGenerateLog = ATTRS(cControlPrefix | 'tp_config', 'Generate TI Log', 'String Value');
Else;
cGenerateLog = 'N';
EndIf;

#*** Log Parameters

If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, TIMST(NOW, '\Y-\m-\d \h:\i:\s'), 'Parameters:', 
pExecutionId, pControl);
EndIf;

cTpPrefix = cControlPrefix | 'tp_';
cTpPrefixLength = LONG(cTpPrefix);

#*** 

cApplicationsDim = cControlPrefix | 'tp_applications';

cApprovalDimensionAttr = 'ApprovalDimension';
cApprovalSubsetAttr = 'ApprovalSubset';
cIsActiveAttr = 'IsActive';
cStoreIdAttr = 'StoreId';
cSecuritySetAttr = 'SecuritySet';

If (DimensionExists(cApplicationsDim) = 0);

If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, 'Create applications dimension');
EndIf;

DimensionCreate(cApplicationsDim);
AttrInsert(cApplicationsDim, '', cApprovalDimensionAttr, 'S');
AttrInsert(cApplicationsDim, '', cApprovalSubsetAttr, 'S');
AttrInsert(cApplicationsDim, '', cIsActiveAttr, 'S');
AttrInsert(cApplicationsDim, '', cStoreIdAttr, 'S');
AttrInsert(cApplicationsDim, '', cSecuritySetAttr, 'S');

SubsetCreate(cApplicationsDim, 'Default');
SubsetIsAllSet(cApplicationsDim, 'Default', 1);

EndIf;

#*** 

cElementSecurityApplicationsCube = '}ElementSecurity_' | cApplicationsDim;

sGroupsDim = '}Groups';

If (CubeExists(cElementSecurityApplicationsCube) = 0);

If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, 'Create applications element security cube');
EndIf;

CubeCreate(cElementSecurityApplicationsCube, cApplicationsDim, sGroupsDim);
CubeSetLogChanges(cElementSecurityApplicationsCube, 1);

EndIf;

#*** 

cPermissionsDim = cControlPrefix | 'tp_permissions';

cView = 'VIEW';
cAnnotate = 'ANNOTATE';
cEdit = 'EDIT';
cReject = 'REJECT';
cSubmit = 'SUBMIT';

If (DimensionExists(cPermissionsDim) = 0);

If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, 'Create permissions dimension');
EndIf;

DimensionCreate(cPermissionsDim);

DimensionElementInsert(cPermissionsDim, '',cView,'S');
DimensionElementInsert(cPermissionsDim, '',cAnnotate,'S');
DimensionElementInsert(cPermissionsDim, '',cEdit,'S');
DimensionElementInsert(cPermissionsDim, '',cReject,'S');
DimensionElementInsert(cPermissionsDim, '',cSubmit,'S');

SubsetCreate(cPermissionsDim, 'Default');
SubsetIsAllSet(cPermissionsDim, 'Default', 1);

EndIf;

#*** 

cNodeInfoDim = cControlPrefix | 'tp_node_info';

cState = 'State';
cViewed = 'Viewed';
cSaved = 'Saved';
cReviewed = 'Reviewed';
cBeingEdited = 'BeingEdited';
cCurrentOwner = 'CurrentOwner';
cCurrentOwnerId = 'CurrentOwnerId';
cStartEditingDate = 'StartEditingDate';
cStateChangeUser = 'StateChangeUser';
cStateChangeDate = 'StateChangeDate';
cDataChangeUser = 'DataChangeUser';
cDataChangeDate = 'DataChangeDate';
cAnnotationChangeUser = 'AnnotationChangeUser';
cAnnotationChangeDate = 'AnnotationChangeDate';

If (DimensionExists(cNodeInfoDim) = 0);

If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, 'Create node info dimension');
EndIf;

DimensionCreate(cNodeInfoDim);

DimensionElementInsert(cNodeInfoDim, '', cState, 'S');
DimensionElementInsert(cNodeInfoDim, '', cViewed, 'S');
DimensionElementInsert(cNodeInfoDim, '', cSaved, 'S');
DimensionElementInsert(cNodeInfoDim, '', cReviewed, 'S');
DimensionElementInsert(cNodeInfoDim, '', cBeingEdited, 'S');
DimensionElementInsert(cNodeInfoDim, '', cCurrentOwner, 'S');
DimensionElementInsert(cNodeInfoDim, '', cCurrentOwnerId, 'S');
DimensionElementInsert(cNodeInfoDim, '', cStartEditingDate, 'S');
DimensionElementInsert(cNodeInfoDim, '', cStateChangeUser, 'S');
DimensionElementInsert(cNodeInfoDim, '', cStateChangeDate, 'S');
DimensionElementInsert(cNodeInfoDim, '', cDataChangeUser, 'S');
DimensionElementInsert(cNodeInfoDim, '', cDataChangeDate, 'S');
DimensionElementInsert(cNodeInfoDim, '', cAnnotationChangeUser, 'S');
DimensionElementInsert(cNodeInfoDim, '', cAnnotationChangeDate, 'S');

EndIf;

#*** 
cStateValidationMeasuresDim = cControlPrefix | 'tp_state_validation_measures';

cNotStarted = 'NotStarted';
cWorkInProgress = 'WorkInProgress';
cLocked = 'Locked';
cInvalidState = 'InvalidState';
cNumericState = 'NumericState';
cInvalidStateType = 'InvalidStateType';
If (DimensionExists(cStateValidationMeasuresDim) = 0);

If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, 'Create state validation measures dimension');
EndIf;

DimensionCreate(cStateValidationMeasuresDim);

DimensionElementInsert(cStateValidationMeasuresDim, '', cNotStarted, 'N');
DimensionElementInsert(cStateValidationMeasuresDim, '', cWorkInProgress, 'N');
DimensionElementInsert(cStateValidationMeasuresDim, '', cLocked, 'N');
DimensionElementInsert(cStateValidationMeasuresDim, '', cInvalidState, 'N');
DimensionElementInsert(cStateValidationMeasuresDim, '', cInvalidStateType, 'S');
EndIf;

#*** Create subset for dimension }Groups

cTpDefaultSubset = 'tp_default';
If (SubsetExists('}Groups', cTpDefaultSubset) = 0);
SubsetCreate('}Groups', cTpDefaultSubset);
SubsetIsAllSet('}Groups', cTpDefaultSubset, 1);
SubsetAliasSet('}Groups', cTpDefaultSubset, '}TM1_DefaultDisplayValue');
EndIf;

#*** No error

If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, 'The end has been reached.');
EndIf;


573,1

574,1

575,132


#################################################################
## IBM Confidential
##
## OCO Source Materials
##
## BI and PM: pmpsvc
##
## (C) Copyright IBM Corp. 2008, 2009
##
## The source code for this program is not published or otherwise
## divested of its trade secrets, irrespective of what has been
## deposited with the U.S. Copyright Office.
#################################################################



#*** Log File Name
cTM1Log = cEpilogLog;

#*** Check security cubes

sDimensionsDim = '}Dimensions';
sDimensionSecurityCube = '}DimensionSecurity';
If (CubeExists(sDimensionSecurityCube) = 0);

If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, 'Create }DimensionSecurity');
EndIf;

CubeCreate(sDimensionSecurityCube, sDimensionsDim, sGroupsDim);
CubeSetLogChanges(sDimensionSecurityCube, 1);
EndIf;

CellPutS('Read', sDimensionSecurityCube, '}Groups', cEveryoneGroup);


sCubesDim = '}Cubes';
sCubeSecurityCube = '}CubeSecurity';
If (CubeExists(sCubeSecurityCube) = 0);

If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, 'Create }CubeSecurity');
EndIf;

CubeCreate(sCubeSecurityCube, sCubesDim, sGroupsDim);
CubeSetLogChanges(sCubeSecurityCube, 1);
EndIf;

sProcessesDim = '}Processes';
sProcessSecurityCube = '}ProcessSecurity';
If (CubeExists(sProcessSecurityCube) = 0);

If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, 'Create }ProcessSecurity');
EndIf;

CubeCreate(sProcessSecurityCube, sProcessesDim, sGroupsDim);
CubeSetLogChanges(sProcessSecurityCube, 1);
EndIf;

#*** Add TP processes to everyone group

cEnterNodeProc = cControlPrefix | 'tp_workflow_enter_node';
cLeaveNodeProc = cControlPrefix | 'tp_workflow_leave_node';
cOwnNodeProc = cControlPrefix | 'tp_workflow_own_node';
cRejectNodeProc = cControlPrefix | 'tp_workflow_reject_node';
cSaveNodeProc = cControlPrefix | 'tp_workflow_save_node';
cSubmitNodeProc = cControlPrefix | 'tp_workflow_submit_node';
cUpdateUserNameProc = cControlPrefix | 'tp_workflow_update_user_name';

CellPutS('Read', sProcessSecurityCube, cEnterNodeProc, cEveryoneGroup);
CellPutS('Read', sProcessSecurityCube, cLeaveNodeProc, cEveryoneGroup);
CellPutS('Read', sProcessSecurityCube, cOwnNodeProc, cEveryoneGroup);
CellPutS('Read', sProcessSecurityCube, cRejectNodeProc, cEveryoneGroup);
CellPutS('Read', sProcessSecurityCube, cSaveNodeProc, cEveryoneGroup);
CellPutS('Read', sProcessSecurityCube, cSubmitNodeProc, cEveryoneGroup);
CellPutS('Read', sProcessSecurityCube, cUpdateUserNameProc, cEveryoneGroup);

#*** 

If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, 'Add applications dimension, its attributes dimension and cube to everyone group');
EndIf;

cApplicationsAttributesDim = '}ElementAttributes_' | cApplicationsDim;
cApplicationsAttributesCube = '}ElementAttributes_' | cApplicationsDim;

CellPutS('Read', sDimensionSecurityCube, cApplicationsDim, cEveryoneGroup);
CellPutS('Read', sDimensionSecurityCube, cApplicationsAttributesDim, cEveryoneGroup);

CellPutS('Read', sCubeSecurityCube, cApplicationsAttributesCube, cEveryoneGroup);

#*** 

If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, 'Add permissions dimension to everyone group');
EndIf;

CellPutS('Read', sDimensionSecurityCube, cPermissionsDim, cEveryoneGroup);

#*** 

If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, 'Add node info dimension to everyone group');
EndIf;

CellPutS('Read', sDimensionSecurityCube, cNodeInfoDim, cEveryoneGroup);

#*** 

If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, 'Set security on error cube');
EndIf;

cErrorCube = cControlPrefix | 'tp_process_errors';
cErrorGuidsDim = cControlPrefix |  'tp_process_guids';
cErrorMeasuresDim = cControlPrefix | 'tp_process_error_measures';

CellPutS('Read', sDimensionSecurityCube, cErrorGuidsDim, cEveryoneGroup);
CellPutS('Read', sDimensionSecurityCube, cErrorMeasuresDim, cEveryoneGroup);

CellPutS('Read', sCubeSecurityCube, cErrorCube, cEveryoneGroup);

#*** No error

If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, 'The end has been reached.');
EndIf;


576,
638,1
804,0
1217,0
900,
901,
902,
903,
906,
907,
908,
904,0
905,0
909,0
911,
912,
913,
914,
915,
916,
917,0
918,1
919,0
920,50000
921,""
922,""
923,0
924,""
925,""
926,""
927,""
